/*
	BromScript - On Runtime Scripting Language.
    Copyright (C) 2012 - 2013  Alex Brouwer (Bromvlieg: http://brom.4o3.nl/)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef BROMSCRIPT_FUNCTION_INCLUDED
#define BROMSCRIPT_FUNCTION_INCLUDED

#include "SIF.h"

#include "Misc.h"
#include "Instance.h"
#include "Variable.h"
#include "ExecuteData.h"
#include "Executer.h"
#include "ArgumentData.h"
#include "Table.h"

namespace BromScript {
	class Function
	{
	public:
		static int GetCount();

		Function(Instance* bromscript);
		~Function();
		
		Variable* Run();
		Variable* Run(Variable* thisobject);
		Variable* Run(ArgumentData* args);
		Variable* Run(ArgumentData* args, Variable* thisobject);
		Variable* Run(List<Variable*>* args);
		Variable* Run(List<Variable*>* args, Variable* thisobject);
		Variable* InternalRun(ExecuteData* data);
		
		void SetVar(Scratch::CString key, Variable* var, bool global);
		Variable* GetVar(Scratch::CString var);

		Instance* BromScript;
		Function* Parent;
		Table* Locals;
		List<Scratch::CString> Parameters;

		Scratch::CString Name;
		Scratch::CString Filename;
		byte* Code;

		int CurrentSourceFileLine;
		bool ForceReturn;
		bool IsCpp;
		BSFunction CppFunc;
		Variable* CurrentThisObject;

	private:
	};
}

#endif