/*
	BromScript - On Runtime Scripting Language.
    Copyright (C) 2012 - 2013  Alex Brouwer (Bromvlieg: http://brom.4o3.nl/)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef BROMSCRIPT_VARIABLE_INCLUDED
#define BROMSCRIPT_VARIABLE_INCLUDED

#include "SIF.h"
#include "Misc.h"

namespace BromScript {
	class Variable
	{
	public:
		static int GetCount();

		enum VariableType {
			Null, String, Bool, Number, Table, Function, Class, Userdata = 9
		};

		Variable(void);
		~Variable(void);
		void* Copy();

		VariableType Type;
		void* Value;

		int Using;
		bool IsCpp;
		BromScript::Userdata* CppData;
		bool DeleteOnDestruct;
		bool RegisteredInGC;
		bool ReadOnly;

		double GetNumber();
		const char* GetString();
		bool GetBool();
		BromScript::Function* GetFunction();
		BromScript::Table* GetTable();
	};
}

#endif